package nl.iobyte.themeparkconnector.api.config.enums;

public enum StorageKey {

    //General
    LICENSE(StorageLocation.SETTINGS, "license"),
    ACTIONFOTO(StorageLocation.SETTINGS, "actionfoto"),

    //Update Settings
    UPDATE_CHECK_ENABLED(StorageLocation.SETTINGS, "update.check"),
    UPDATE_DOWNLOAD_ENABLED(StorageLocation.SETTINGS, "update.download"),

    //Sign
    SIGN_CONTROL_NAME(StorageLocation.SETTINGS, "sign.control.name"),
    SIGN_CONTROL_TITLE(StorageLocation.SETTINGS, "sign.control.title"),
    SIGN_SCAN_NAME(StorageLocation.SETTINGS, "sign.scan.name"),
    SIGN_SCAN_TITLE(StorageLocation.SETTINGS, "sign.scan.title"),

    //Socket
    SOCKET_ID(StorageLocation.SETTINGS, "socket.id"),
    SOCKET_URL(StorageLocation.SETTINGS, "socket.url"),
    SOCKET_PANEL_URL(StorageLocation.SETTINGS, "socket.panel");

    private final StorageLocation location;
    private final String path;
    StorageKey(StorageLocation location, String path) {
        this.location = location;
        this.path = path;
    }

    /**
     * Get storage location key is stored in
     * @return StorageLocation
     */
    public StorageLocation getLocation() {
        return location;
    }

    /**
     * Get path to value
     * @return String
     */
    public String getPath() {
        return path;
    }

}
