package nl.iobyte.themeparkconnector.api.event.ticket;

import nl.iobyte.themeparkconnector.api.show.objects.Ticket;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import java.util.UUID;

public class TicketScanEvent extends Event implements Cancellable {

    private static final HandlerList handlers = new HandlerList();

    private final UUID uuid;
    private final Ticket ticket;
    private final boolean valid;

    private boolean cancel = false;

    public TicketScanEvent(UUID uuid, Ticket ticket, boolean valid) {
        this.uuid = uuid;
        this.ticket = ticket;
        this.valid = valid;
    }

    public UUID getUUID() {
        return uuid;
    }

    public Ticket getTicket() {
        return ticket;
    }

    public boolean isValid() {
        return valid;
    }

    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }

    @Override
    public boolean isCancelled() {
        return cancel;
    }

    @Override
    public void setCancelled(boolean b) {
        cancel = b;
    }

}
