package nl.iobyte.themeparkconnector.api.packet.adapter;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import nl.iobyte.themepark.api.attraction.enums.Status;
import java.lang.reflect.Type;

public class StatusAdapter implements JsonSerializer<Status> {

    /**
     * Serializes Status to json
     * @param src Status
     * @param type Type
     * @param context JsonSerializationContext
     * @return JsonElement
     */
    @Override
    public JsonElement serialize(Status src, Type type, JsonSerializationContext context) {
        JsonObject result = new JsonObject();
        result.add("id", context.serialize(src.getID()));
        result.add("name", context.serialize(src.getName()));
        result.add("hex", context.serialize(src.getHexColor()));

        return result;
    }

}