package nl.iobyte.themeparkconnector.api.player;

import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.ThemeParkConnectorAPI;
import nl.iobyte.themeparkconnector.api.client.ClientConnection;
import nl.iobyte.themeparkconnector.api.state.states.IdleState;
import org.bukkit.Bukkit;
import java.util.concurrent.atomic.AtomicLong;

public class PlayerStateService {

    private int TaskID = 0;
    private int strike = 0;

    /**
     * Try to start pushing player state data
     */
    public void start() {
        if(TaskID != 0)
            return;

        //Check if shutting down
        if(ThemeParkConnector.getInstance().isDisabling())
            return;

        //Start pushing data asynchronously
        strike = -1;
        AtomicLong stamp = new AtomicLong(System.currentTimeMillis());
        ThemeParkConnectorAPI api = ThemeParkConnector.getInstance().getAPI();
        TaskID = Bukkit.getScheduler().runTaskTimerAsynchronously(ThemeParkConnector.getInstance(), () -> {
            int connected = 0;
            for(ClientConnection client : api.getNetworkingService().getClients())
                if(client.isConnected())
                    connected++;

            //If no players connected add strike
            if(connected != 0) {
                strike = 0;
                return;
            }

            strike++;
            if(strike > 2) {
                api.getNetworkingService().stop();
                api.getStateService().setState(new IdleState("No users online, closed connection"));
            }
        }, 0, 10 * 20).getTaskId();
    }

    /**
     * Stop pushing player state data
     */
    public void stop() {
        if(TaskID == 0)
            return;

        Bukkit.getScheduler().cancelTask(TaskID);
        TaskID = 0;
    }

}
