package nl.iobyte.themeparkconnector.commands.subcommands;

import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.ThemeParkConnectorAPI;
import nl.iobyte.themeparkconnector.api.client.ClientConnection;
import nl.iobyte.themeparkconnector.api.state.objects.AbstractState;
import nl.iobyte.themeparkconnector.api.message.Text;
import org.bukkit.Bukkit;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import org.bukkit.entity.Player;
import java.util.List;

public class StatusCommand extends SubCommand {

    public StatusCommand() {
        super("themeparkconnector.admin", "status");

        addSyntax("/themeparkconnector status");
    }

    //Give ICommandExecutor overview of Plugin status
    public void onCommand(ICommandExecutor sender, List<Object> objects, int i) {
        ThemeParkConnectorAPI api = ThemeParkConnector.getInstance().getAPI();
        AbstractState state = api.getStateService().getCurrentState();

        sender.sendMessage(Text.color("&f&l>==== &6&lThemeParkConnector &l&f====<"));
        sender.sendMessage(Text.color("&6State: &f"+state.getType()));
        sender.sendMessage(Text.color("&6Clients: &f"+getClientCount()+"&6/&f"+ Bukkit.getOnlinePlayers().size()));
        sender.sendMessage(Text.color("&6Description:"));
        sender.sendMessage(Text.color("&f"+state.getDescription()));
        sender.sendMessage(Text.color("&f&l>==== &6&lThemeParkConnector &l&f====<"));
    }

    //Get clients connected to ThemeParkConnector
    private String getClientCount() {
        int i = 0;
        for(ClientConnection client : ThemeParkConnector.getInstance().getAPI().getNetworkingService().getClients())
            if(client.isConnected())
                i++;

        return Integer.toString(i);
    }

}
